namespace CSV {
	string[][] FromFile(const string &in filePath) {
		IO::File file(filePath, IO::FileMode::Read);
		string data = file.ReadToEnd();
		file.Close();
		return FromString(data);
	}

	string[][] FromFileSource(const string &in filePath) {
		IO::FileSource file(filePath);
		string data = file.ReadToEnd();
		return FromString(data);
	}

	// @TODO: Add inline commata support
	string[][] FromString(const string &in data) {
		string[][] ret;
		string[] lines = data.Replace("\r", "").Split("\n"); // mind CRLF
		for (uint i = 0; i < lines.Length; i++) {
			lines[i] = lines[i].Replace("\\n", "\n"); // Multilines using \n
			ret.InsertLast(lines[i].Split(","));
		}
		return ret;
	}
}