class ActiveEffect {
	string m_scriptName;
	uint64 m_endTime;
	bool m_started;

	bool ApplyStart() {
		return true;
	}

	void ApplyLoop() {
		return;
	}

	bool ApplyEnd() {
		return true;
	}

	ActiveEffect(const string &in scriptName, uint duration) {
		m_scriptName = scriptName;
		m_endTime = Time::Now + duration;
	}
}

namespace ActiveEffect {
	enum Type {
		Unknown,
		TwitchPlays,
		FakeFinish,
		FakeIntro,
		ChatAsBigMessage,
		FakeGamecrash
	}

	Type FromString(const string &in value) {
		if (value == "TwitchPlays") {
			return Type::TwitchPlays;
		}
		if (value == "FakeFinish") {
			return Type::FakeFinish;
		}
		if (value == "FakeIntro") {
			return Type::FakeIntro;
		}
		if (value == "ChatAsBigMessage") {
			return Type::ChatAsBigMessage;
		}
		if (value == "FakeGamecrash") {
			return Type::FakeGamecrash;
		}
		return Type::Unknown;
	}
}

void ActiveEffectLoop() {
	while (true) {
		for (uint i = 0; i < g_chaosMode.m_activeEffects.Length; i++) {
			if (!g_chaosMode.m_activeEffects[i].m_started) {
				g_chaosMode.m_activeEffects[i].m_started = g_chaosMode.m_activeEffects[i].ApplyStart();
			} else if (Time::Now > g_chaosMode.m_activeEffects[i].m_endTime) {
				if (g_chaosMode.m_activeEffects[i].ApplyEnd()) g_chaosMode.m_activeEffects.RemoveAt(i);
				i--;
			} else {
				g_chaosMode.m_activeEffects[i].ApplyLoop();
			}
		}

		yield();
	}
}