bool SendCustomEvent(const string &in title, array<string> data) {
	auto app = cast<CGameManiaPlanet>(GetApp());
	auto network = app.Network;
	auto maniaApp = cast<CGameManiaAppPlayground>(network.ClientManiaAppPlayground);
	if (maniaApp is null) {
		error("ManiaApp was null whilst trying to send event");
		return false;
	}

	MwFastBuffer<wstring> eventData;
	for (uint i = 0; i < data.Length; i++) {
		eventData.Add(data[i]);
	}
	maniaApp.SendCustomEvent(title, eventData);
	/* @debug
	string logString = "Sent" + title + " (";
	for (uint i = 0; i < eventData.Length; i++) {
		if (i > 0) logString += ", ";
		logString += eventData[i];
	}
	trace(logString + ")");
	*/
	return true;
}

bool SetClientUISequence(CGamePlaygroundUIConfig::EUISequence uiSequence) {
	auto app = cast<CGameManiaPlanet>(GetApp());
	auto network = app.Network;
	auto maniaApp = cast<CGameManiaAppPlayground>(network.ClientManiaAppPlayground);
	if (maniaApp is null) {
		error("ManiaApp was null whilst trying to change sequence");
		return false;
	}
	
	if (maniaApp.ClientUI is null) {
		error("ClientUI was null whilst trying to change sequence");
		return false;
	}

	maniaApp.ClientUI.UISequence = uiSequence;
	return true;
}

bool SetClientUIBigMessage(const string &in message) {
	auto app = cast<CGameManiaPlanet>(GetApp());
	auto network = app.Network;
	auto maniaApp = cast<CGameManiaAppPlayground>(network.ClientManiaAppPlayground);
	if (maniaApp is null) {
		error("ManiaApp was null whilst trying to change sequence");
		return false;
	}
	
	if (maniaApp.ClientUI is null) {
		error("ClientUI was null whilst trying to change sequence");
		return false;
	}

	maniaApp.ClientUI.BigMessage = message;
	return true;
}

CGameManiaAppPlaygroundScriptEvent@[] GetManiaAppPendingEvents() {
	auto app = cast<CGameManiaPlanet>(GetApp());
	auto network = app.Network;
	auto maniaApp = cast<CGameManiaAppPlayground>(network.ClientManiaAppPlayground);

	array<CGameManiaAppPlaygroundScriptEvent@> pendingEvents;
	if (maniaApp is null) {
		error("ManiaApp was null whilst trying to fetch it's events");
		return pendingEvents;
	}

	for (uint i = 0; i < maniaApp.PendingEvents.Length; i++) {
		pendingEvents.InsertLast(maniaApp.PendingEvents[i]);
	}
	return pendingEvents;
}

int GetMapGoldTime() {
	auto app = cast<CGameManiaPlanet>(GetApp());
	if (app.RootMap is null) return -1;
	return app.RootMap.TMObjective_GoldTime;
}