class PollEffect {
	string m_scriptName;
	string m_displayName;
	int m_duration;
	string m_variationData;

	void Start() {
		string[] MLEventData;
		MLEventData.InsertLast(m_scriptName);
		MLEventData.InsertLast(tostring(m_duration));
		MLEventData.InsertLast(m_displayName);
		MLEventData.InsertLast(m_variationData);
		SendCustomEvent("ChaosMode.NewEffect", MLEventData);

		ActiveEffect::Type pluginEffectType = ActiveEffect::FromString(m_scriptName);
		switch (pluginEffectType) {
			case ActiveEffect::Type::TwitchPlays:
				g_chaosMode.m_activeEffects.InsertLast(TwitchPlaysEffect(m_scriptName, m_duration));
				break;
			case ActiveEffect::Type::FakeGamecrash:
				g_chaosMode.m_activeEffects.InsertLast(FakeGamecrashEffect(m_scriptName, m_duration));
				break;
			case ActiveEffect::Type::FakeFinish:
				g_chaosMode.m_activeEffects.InsertLast(FakeFinishEffect(m_scriptName, m_duration));
				break;
			case ActiveEffect::Type::FakeIntro:
				g_chaosMode.m_activeEffects.InsertLast(FakeIntroEffect(m_scriptName, m_duration));
				break;
			case ActiveEffect::Type::ChatAsBigMessage:
				g_chaosMode.m_activeEffects.InsertLast(ChatAsBigMessageEffect(m_scriptName, m_duration));
				break;
		}
	}

	PollEffect(const string &in scriptName, const string &in displayName, int duration, const string &in variationData) {
		m_scriptName = scriptName;
		m_displayName = displayName;
		m_duration = duration;
		m_variationData = variationData;
	}
}