class FreeplayBinding {
	VirtualKey m_binding;
	string m_effectScriptName;

	EffectTemplate@ GetBindingEffect() {
		for (uint i = 0; i < g_chaosMode.m_effectTemplates.Length; i++) {
			if (m_effectScriptName == g_chaosMode.m_effectTemplates[i].m_scriptName) return g_chaosMode.m_effectTemplates[i];
		}
		return null;
	}

	FreeplayBinding(VirtualKey _key, const string &in _scriptName) {
		m_binding = _key;
		m_effectScriptName = _scriptName;
	}

	FreeplayBinding() {}
}

void OnKeyPress(bool down, VirtualKey key) {
	if (!down) return;

	if (g_chaosMode.m_bindingModeActive) {
		g_chaosMode.m_newBinding.m_binding = key;
		g_chaosMode.m_bindingModeActive = false;
		return;
	}

	if (g_chaosMode.m_freeplayActive) {
		for (uint i = 0; i < g_chaosMode.m_freeplayBindings.Length; i++) {
			if (
				g_chaosMode.m_freeplayBindings[i].m_binding == key &&
				!(
					(g_chaosMode.m_gameMode == GameMode::Multi && (g_chaosMode.m_freeplayBindings[i].GetBindingEffect().m_availability & EffectAvailability::MultiplayerOnly == 0)) ||
					(g_chaosMode.m_gameMode != GameMode::Multi && (g_chaosMode.m_freeplayBindings[i].GetBindingEffect().m_availability & EffectAvailability::SingleplayerOnly == 0))
				)
			) {
				g_chaosMode.m_freeplayBindings[i].GetBindingEffect().generatePollEffect().Start();
			}
		}
	}
}