int g_pluginId;
ChaosMode@ g_chaosMode = ChaosMode();

int g_nvgFont;
UI::Font@ g_uiFontBold;

// @TODO
enum EffectType {
	WarnedByAdmin,
	RemoteControlPlayer, //< DoubleDriver but its an effect lol
	RestartWhenCrashing,
}
// Failed / Discarded / Given Up:
/*
	- BlurredScreen (Player can just diable blur manialink)
	- SpecialsAreLava (Cannot get playground events other than coding a ManiaApp directly)
	- ExtremeFog (Needs preconfigured Mediatracker block on map)
	- Force Skin XYZ (No real "Chaos" effect)
*/

void Main() {
	// explicit club-edition check
	if (Permissions::CanSubscribeToClub()) {
		UI::ShowNotification(Icons::ExclamationTriangle + "  Club edition required!", "Until the next big update of this plugin where necessary stuff for standard-allowance is checked, club edition will be required to play Chaos mode.", vec4(0.6, 0.6, 1.0, 0.27), 30000);
		warn("Until the next big update of this plugin where necessary stuff for standard-allowance is checked, club edition will be required to play Chaos mode.");
		return;
	}

	g_nvgFont = nvg::LoadFont("DroidSans.ttf");
	@g_uiFontBold = UI::LoadFont("DroidSans-Bold.ttf");

	LoadEffects();
	startnew(PollLoop);

	if (Setting_TMDataLastSave != Meta::ExecutingPlugin().Version) {
		startnew(CopyModeFiles);
	}

#if DEPENDENCY_TWITCHBASE
	startnew(TwitchLoop);
#else
	UI::ShowNotification(Icons::ExclamationTriangle + "  No Twitch Support!", "Please install the \"Twitch Base\" plugin to have working Twitch support! There's an easy setup guide on its plugin page aswell.", vec4(0.6, 0.6, 1.0, 0.27), 30000);
	warn("Please install the \"Twitch Base\" plugin to have working Twitch support! There's an easy setup guide on it's plugin page aswell.");
#endif

	startnew(ActiveEffectLoop);

	startnew(RMCLoop);
}

void Render() {
	// explicit club-edition check
	if (Permissions::CanSubscribeToClub()) return;

	if (g_chaosMode.m_currentPoll is null) return;

	RenderPollProgress();
	if (Setting_UseTwitch) RenderPollBox();
}

void RenderInterface() {
	// explicit club-edition check
	if (Permissions::CanSubscribeToClub()) return;

	if (!Setting_WindowVisible || g_chaosMode is null) return;

	if (Setting_MovePollBox) {
		Locator::Render("Poll HUD", Setting_PollBoxPos, Setting_PollBoxSize);
		Setting_PollBoxPos = Locator::GetPos();
		Setting_PollBoxSize = Locator::GetSize();
	}
	
	UI::SetNextWindowSize(465,315);
	if (UI::Begin("\\$f50" + Icons::Fire + "\\$fff  Chaos Mode \\$555 by Nsgr###ChaosMode", Setting_WindowVisible, UI::WindowFlags::NoScrollbar | UI::WindowFlags(1 << 21) | UI::WindowFlags::NoCollapse)) {
		g_chaosMode.m_ui.Render();
		UI::End();
	}
}

void RenderMenu() {
	// explicit club-edition check
	if (Permissions::CanSubscribeToClub()) return;
	
	if (UI::MenuItem("\\$f50" + Icons::Fire + "\\$fff  Chaos Mode", "", Setting_WindowVisible)) {
		Setting_WindowVisible = !Setting_WindowVisible;
	}
}

#if DEPENDENCY_TWITCHBASE
void OnDisabled() {
	if (g_pluginId > 0) Twitch::Unregister(g_pluginId);
	g_pluginId = 0;
}

void OnDestroyed() {
	if (g_pluginId > 0) Twitch::Unregister(g_pluginId);
	g_pluginId = 0;
}
#endif

// Other methods
void LoadEffects() {
	string[][] csvData = CSV::FromFileSource("data/Effects.csv");
	if (csvData.Length < 2) {
		throw("CSV data has to be of minimum 2 lines!");
	}

	// header
	// line sanity check
	uint lineCountSanityCheck = csvData[0].Length;
	for (uint i = 1; i < csvData.Length; i++) {
		if (csvData[i].Length != lineCountSanityCheck) {
			throw("Invalid csv line length in line " + i);
		}
	}

	// indices sanity check
	int scriptNameIndex = -1;
	int displayNameIndex = -1;
	int timeTypeIndex = -1;
	int availabilityIndex = -1;
	for (uint i = 0; i < csvData[0].Length; i++) {
		// switch case only supports integral numbers, not strings smh
		if (csvData[0][i] == "scriptName") {
			scriptNameIndex = i;
		} else if (csvData[0][i] == "displayName") {
			displayNameIndex = i;
		} else if (csvData[0][i] == "timeType") {
			timeTypeIndex = i;
		} else if (csvData[0][i] == "availability") {
			availabilityIndex = i;
		}
	}
	if (scriptNameIndex < 0 || timeTypeIndex < 0 || displayNameIndex < 0 || availabilityIndex < 0) {
		throw("Invalid csv header indices!");
	}

	for (uint i = 1; i < csvData.Length; i++) {
#if !DEPENDENCY_TWITCHBASE
		if (csvData[i][scriptNameIndex] == "TwitchPlays" || csvData[i][scriptNameIndex] == "ChatAsBigMessage") continue;
#endif
		g_chaosMode.m_effectTemplates.InsertLast(
			EffectTemplate (
				csvData[i][scriptNameIndex],
				csvData[i][displayNameIndex],
				Text::ParseInt(csvData[i][timeTypeIndex]),
				Text::ParseInt(csvData[i][availabilityIndex])
			)
		);
	}

	/* @debug
	string constValueDefinitions = "#Const C_EffectType_Null 0\n";
	string constScriptNameArray = "#Const C_EffectTypeIds [\n";
	for (uint i = 1; i < csvData.Length; i++) {
		constValueDefinitions += "#Const C_EffectType_" + csvData[i][scriptNameIndex] + " " + i + "\n";
		constScriptNameArray += "\t" + i + " => \"" + csvData[i][scriptNameIndex] + "\"";
		if (i != csvData.Length - 1) {
			constScriptNameArray += ",";
		}
		constScriptNameArray += "\n";
	}
	IO::SetClipboard(constValueDefinitions + "\n" + constScriptNameArray + "]");
	*/
}

void CopyModeFiles() {
	string[] files = CSV::FromFileSource("data/Files.csv")[0];
	for (uint i = 0; i < files.Length; i++) {
		string sourceFile = IO::FileSource("ModeFiles/" + files[i]).ReadToEnd();

		// Need to create the folder before writing the file.
		string fileToWrite = IO::FromUserGameFolder(files[i]);
		// Cut off the file part to only create a folder until there.
		string fileNameOfPath = fileToWrite.Split("/")[fileToWrite.Split("/").Length - 1];
		string folderToCreate = fileToWrite.SubStr(0, fileToWrite.Length - fileNameOfPath.Length);
		IO::CreateFolder(folderToCreate);
		// Write file.
		IO::File destFile(fileToWrite, IO::FileMode::Write);
		destFile.Write(sourceFile);
		destFile.Close();
	}
	// If no errors happened, we land here
	Setting_TMDataLastSave = Meta::ExecutingPlugin().Version;
}

CTrackManiaPlayerInfo@ GetMainUserInfo() {
	auto app = cast<CTrackMania>(GetApp());
	return cast<CTrackManiaPlayerInfo>(cast<CTrackManiaNetwork>(app.Network).PlayerInfo);
}

string GenerateLocalSettingsXML() {
	return "<root><setting name=\"S_AllowedHostLogins\" value=\"" + GetMainUserInfo().Login + "\" type=\"text\"/></root>";
}

uint GetSuitableEffectCount() {
	uint returnValue = g_chaosMode.m_effectTemplates.Length;
	for (uint i = 0; i < g_chaosMode.m_effectTemplates.Length; i++) {
		if (
			(g_chaosMode.m_gameMode == GameMode::Multi && (g_chaosMode.m_effectTemplates[i].m_availability & EffectAvailability::MultiplayerOnly == 0)) ||
			(g_chaosMode.m_gameMode != GameMode::Multi && (g_chaosMode.m_effectTemplates[i].m_availability & EffectAvailability::SingleplayerOnly == 0)) ||
			!g_chaosMode.m_effectTemplates[i].m_isEnabled
		) returnValue--;
	}
	return returnValue;
}

void StartLocalRun() {
	MwFastBuffer<wstring> mapList;
	auto titleControl = cast<CGameManiaPlanet>(GetApp()).ManiaTitleControlScriptAPI;
	for (uint i = 0; i < g_chaosMode.m_selectedMaps.Length; i++) {
		mapList.Add(g_chaosMode.m_selectedMaps[i].m_path);
	}
	titleControl.PlayMapList(mapList, "TrackMania/ChaosMode", GenerateLocalSettingsXML());
	if (titleControl.LatestResult != CGameManiaTitleControlScriptAPI::EResult::Success) {
		string completeResult = "";
		for (uint i = 0; i < titleControl.CustomResultData.Length; i++) {
			completeResult += titleControl.CustomResultData[i] + "\n";
		}
		error(tostring(titleControl.LatestResult) + "\n" + titleControl.CustomResultType + "\n" + completeResult);
		UI::ShowNotification(tostring(titleControl.LatestResult), titleControl.CustomResultType + "\n" + completeResult);
		if (titleControl.LatestResult == CGameManiaTitleControlScriptAPI::EResult::Error_DataMgr) {
			UI::ShowNotification(Icons::Times + "  Bruh", "\\$f66Selecting an unvalidated / incompatible map for local play freezes the Game title control. You will need to reboot the game.", vec4(1.0, 0.0, 0.0, 0.27), 60000);
		}
		@g_chaosMode.m_currentPoll = null;
		g_chaosMode.m_ui.m_tabState = TabState::ModeSettings;
	} else {
		@g_chaosMode.m_currentPoll = Poll(int(Math::Round(Setting_PollDuration * 1000.0)));
		g_chaosMode.m_ui.m_tabState = TabState::Running;
	}
}

void StartMultiRun() {
	@g_chaosMode.m_currentPoll = Poll(int(Math::Round(Setting_PollDuration * 1000.0)));
	g_chaosMode.m_ui.m_tabState = TabState::Running;
}

void StartFreeplayRun() {
	MwFastBuffer<wstring> mapList;
	auto titleControl = cast<CGameManiaPlanet>(GetApp()).ManiaTitleControlScriptAPI;
	for (uint i = 0; i < g_chaosMode.m_selectedMaps.Length; i++) {
		mapList.Add(g_chaosMode.m_selectedMaps[i].m_path);
	}
	titleControl.PlayMapList(mapList, "TrackMania/ChaosMode", GenerateLocalSettingsXML());
	if (titleControl.LatestResult != CGameManiaTitleControlScriptAPI::EResult::Success) {
		string completeResult = "";
		for (uint i = 0; i < titleControl.CustomResultData.Length; i++) {
			completeResult += titleControl.CustomResultData[i] + "\n";
		}
		error(tostring(titleControl.LatestResult) + "\n" + titleControl.CustomResultType + "\n" + completeResult);
		UI::ShowNotification(tostring(titleControl.LatestResult), titleControl.CustomResultType + "\n" + completeResult);
		if (titleControl.LatestResult == CGameManiaTitleControlScriptAPI::EResult::Error_DataMgr) {
			UI::ShowNotification(Icons::Times + "  Bruh", "\\$f66Selecting an unvalidated / incompatible map for local play freezes the Game title control. You will need to reboot the game.", vec4(1.0, 0.0, 0.0, 0.27), 60000);
		}
		g_chaosMode.m_freeplayActive = false;
		g_chaosMode.m_ui.m_tabState = TabState::ModeSettings;
	} else {
		g_chaosMode.m_freeplayActive = true;
		g_chaosMode.m_ui.m_tabState = TabState::Running;
	}
}