void RenderPollProgress() {
	float progressSize = 1.0 - (float(g_chaosMode.m_currentPoll.m_timeLeft) / float(g_chaosMode.m_currentPoll.m_duration));
	nvg::BeginPath();
	nvg::Rect(0, 0, Draw::GetWidth() * progressSize, Draw::GetHeight() * 0.02);
	nvg::FillColor(vec4(1,1,1,0.5));
	nvg::Fill();
	nvg::ClosePath();
}

void RenderPollBox() {
	vec2 screenSize = vec2(Draw::GetWidth(), Draw::GetHeight());
	vec2 pos = Setting_PollBoxPos * (screenSize - Setting_PollBoxSize);
	nvg::Translate(pos.x, pos.y);
	
	float tileHeight = Setting_PollBoxSize.y / (g_chaosMode.m_currentPoll.m_options.Length + 1);

	nvg::BeginPath();
	nvg::FontFace(g_nvgFont);

	// total vote counter
	nvg::FontSize(tileHeight * 0.8);
	nvg::TextAlign(nvg::Align::Center | nvg::Align::Top);
	nvg::FillColor(vec4(1,1,1,1));
	nvg::TextBox(0, 0, Setting_PollBoxSize.x, "" + g_chaosMode.m_currentPoll.m_totalVotes + " votes");

	// draw vote options
	float totalVotes = float(g_chaosMode.m_currentPoll.m_totalVotes);
	float leaderVotes = float(g_chaosMode.m_currentPoll.m_options[g_chaosMode.m_currentPoll.LeadingIndex()].m_votes);
	float rectHeight = tileHeight * 0.6;
	float rounding = rectHeight / 2.0;
	nvg::FontSize(rectHeight * 0.6);
	for (uint i = 0; i < g_chaosMode.m_currentPoll.m_options.Length; i++) {
		float baseHeight = (i+1) * tileHeight;

		// bar background
		nvg::BeginPath();
		nvg::FillColor(vec4(0.2,0.2,0.2,0.8));
		nvg::RoundedRect(0, baseHeight, Setting_PollBoxSize.x, rectHeight, rounding);
		nvg::Fill();
		float votePercentage = 0;
		float votePercentageComparedToLeader = 0;

		// bar foreground (only drawn when votes calculatable)
		if (totalVotes > 0) {
			votePercentage = g_chaosMode.m_currentPoll.m_options[i].m_votes / totalVotes;
			votePercentageComparedToLeader = (g_chaosMode.m_currentPoll.m_options[i].m_votes / leaderVotes);

			nvg::BeginPath();
			nvg::FillColor(vec4(Setting_PollBoxColor.x,Setting_PollBoxColor.y,Setting_PollBoxColor.z,votePercentageComparedToLeader));
			nvg::RoundedRect(0, baseHeight, Math::Max(rounding * 2.0, Setting_PollBoxSize.x * votePercentage), rectHeight, rounding);
			nvg::Fill();
		}

		// texts
		nvg::FillColor(vec4(1,1,1,1));

		nvg::TextAlign(nvg::Align::Left | nvg::Align::Middle);
		nvg::Text(rounding, baseHeight + rounding, "" + g_chaosMode.m_currentPoll.m_options[i].m_selector);

		nvg::TextAlign(nvg::Align::Center | nvg::Align::Middle);
		nvg::Text(Setting_PollBoxSize.x / 2.0, baseHeight + rounding, "" + g_chaosMode.m_currentPoll.m_options[i].m_effect.m_displayName);

		nvg::TextAlign(nvg::Align::Right | nvg::Align::Middle);
		nvg::Text(Setting_PollBoxSize.x - rounding, baseHeight + rounding, int(Math::Round(votePercentage * 100)) + "%");
	}
	
	nvg::ResetTransform();
}