[Setting category="General" name="Show window" hidden]
bool Setting_WindowVisible = true;

[Setting category="General" name="Last saved TMData version" hidden]
string Setting_TMDataLastSave = "";


[Setting category="Chaos" name="Default Standard effect duration (seconds)"]
float Setting_EffectDuration = 30.0;

[Setting category="Chaos" name="Default Short effect duration (seconds)"]
float Setting_ShortEffectDuration = 10.0;

[Setting category="Chaos" name="Selection interval" description="= poll duration for Twitch"]
float Setting_PollDuration = 25.0;

[Setting category="Chaos" name="Proportional Voting" description="60% of votes = 60% chance the option is picked"]
bool Setting_ProportionalVoting = false;


[Setting category="Twitch" name="Use Twitch connection instead of Randomizer" description="Requires the \"Twitch Base\" plugin to be set up"]
bool Setting_UseTwitch = false;

[Setting category="Twitch" name="Amount of poll options"]
int Setting_PollOptions = 3;

[Setting category="Twitch" name="Allow only one vote per user"]
bool Setting_BlockDoubleVotes = true;

[Setting category="Twitch" name="Alternate poll option selectors" description="Alternating between 1,2,3... and other numbers helps to avoid the twitch delay change follow-up poll results"]
bool Setting_AlternatePollOptions = true;


[Setting category="Poll HUD" name="Enable Overlay Locator mode"]
bool Setting_MovePollBox = false;

[Setting category="Poll HUD" name="Position"]
vec2 Setting_PollBoxPos = vec2(0.75,0.25);

[Setting category="Poll HUD" name="Size"]
vec2 Setting_PollBoxSize = vec2(360,200);

[Setting category="Poll HUD" name="Highlight Color" color]
vec3 Setting_PollBoxColor = vec3(0.1,0.5,0.9);


void OnSettingsChanged() {
	if (Setting_PollOptions < 1) Setting_PollOptions = 1;
#if !DEPENDENCY_TWITCHBASE
	if (Setting_UseTwitch) {
		UI::ShowNotification(Icons::ExclamationTriangle + "  No Twitch Support!", "Please install the \"Twitch Base\" plugin to have working Twitch support! There's an easy setup guide on it's plugin page aswell.", vec4(0.6, 0.6, 1.0, 0.27), 30000);
		warn("Please install the \"Twitch Base\" plugin to have working Twitch support! There's an easy setup guide on it's plugin page aswell.");
		Setting_UseTwitch = false;
	}
#endif
}