#if DEPENDENCY_TWITCHBASE
void TwitchLoop() {
	while (true) {
		// Standard registration / fetch
		if (g_pluginId == 0) g_pluginId = Twitch::Register(Twitch::MessageType::ChatMessage);
		array<Twitch::Message@> newMessages = Twitch::Fetch(g_pluginId);

		// Only handle new messages when we need to
		if (g_chaosMode.m_currentPoll !is null) {
			for (uint i = 0; i < newMessages.Length; i++) {

				// Check if message could select a poll option
				uint selector = Text::ParseUInt(newMessages[i].m_text);
				if (selector < 1) {

					// No -> Handle message for Special Effects
					for (uint j = 0; j < g_chaosMode.m_activeEffects.Length; j++) {
						if (cast<TwitchPlaysEffect@>(g_chaosMode.m_activeEffects[j]) !is null) {
							if (newMessages[i].m_text == "<<") {
								cast<TwitchPlaysEffect@>(g_chaosMode.m_activeEffects[j]).addInput(TwitchPlays::InputType::Left);
							} else if (newMessages[i].m_text == ">>") {
								cast<TwitchPlaysEffect@>(g_chaosMode.m_activeEffects[j]).addInput(TwitchPlays::InputType::Right);
							} else if (newMessages[i].m_text == "--") {
								cast<TwitchPlaysEffect@>(g_chaosMode.m_activeEffects[j]).addInput(TwitchPlays::InputType::Brake);
							}
						} else if (cast<ChatAsBigMessageEffect@>(g_chaosMode.m_activeEffects[j]) !is null) {
							cast<ChatAsBigMessageEffect@>(g_chaosMode.m_activeEffects[j]).m_message = "Hello " + newMessages[i].m_username + "!";
						}
					}
				} else if (Setting_UseTwitch) {

					// Yes -> Handle message for Poll
					// We first check if the message fits a poll selector, THEN if the user already voted.
					for (uint j = 0; j < g_chaosMode.m_currentPoll.m_options.Length; j++) {
						if (g_chaosMode.m_currentPoll.m_options[j].m_selector == selector) {
							if (g_chaosMode.m_currentPoll.m_voters.Find(newMessages[i].m_username) > 0) {
								if (Setting_BlockDoubleVotes) break;
							} else {
								g_chaosMode.m_currentPoll.m_voters.InsertLast(newMessages[i].m_username);
							}
							g_chaosMode.m_currentPoll.m_totalVotes++;
							g_chaosMode.m_currentPoll.m_options[j].m_votes++;
							break;
						}
					}
				}
				
			}
		}

		yield();
	}
}
#endif